diff --git a/sys/dev/drm/include/linux/hwmon.h b/sys/dev/drm/include/linux/hwmon.h
new file mode 100644
index 0000000000..9a32454b50
--- /dev/null
+++ b/sys/dev/drm/include/linux/hwmon.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: hwmon.h,v 1.1 2014/07/16 20:59:58 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef	_LINUX_HWMON_H_
+#define	_LINUX_HWMON_H_
+
+#endif	/* _LINUX_HWMON_H_ */
diff --git a/sys/dev/drm/include/linux/i2c.h b/sys/dev/drm/include/linux/i2c.h
index 5cb881b85f..193731ecba 100644
--- a/sys/dev/drm/include/linux/i2c.h
+++ b/sys/dev/drm/include/linux/i2c.h
@@ -62,4 +62,17 @@ struct i2c_algorithm {
 extern int i2c_add_adapter(struct i2c_adapter *);
 extern void i2c_del_adapter(struct i2c_adapter *);
 
+struct i2c_board_info {
+	char		type[I2C_NAME_SIZE];
+	unsigned short	flags;
+	unsigned short	addr;
+	void		*platform_data;
+//	struct dev_archdata	*archdata;
+	struct device_node *of_node;
+//	struct acpi_dev_node acpi_node;
+	int		irq;
+};
+#define I2C_BOARD_INFO(dev_type, dev_addr) \
+	.type = dev_type, .addr = (dev_addr)
+
 #endif	/* _LINUX_I2C_H_ */
diff --git a/sys/dev/drm/include/linux/init.h b/sys/dev/drm/include/linux/init.h
new file mode 100644
index 0000000000..6847a4b771
--- /dev/null
+++ b/sys/dev/drm/include/linux/init.h
@@ -0,0 +1,35 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_INIT_H
+#define _LINUX_INIT_H
+
+#endif /* _LINUX_INIT_H */
diff --git a/sys/dev/drm/include/linux/kernel.h b/sys/dev/drm/include/linux/kernel.h
index 8197c769d5..7d8fa9f7a9 100644
--- a/sys/dev/drm/include/linux/kernel.h
+++ b/sys/dev/drm/include/linux/kernel.h
@@ -62,6 +62,7 @@
 
 #define	simple_strtoul	strtoul
 #define	simple_strtol	strtol
+#define	kstrtol(a,b,c)	({*(c) = strtol(a,0,b);})
 
 #define min(x, y)			((x) < (y) ? (x) : (y))
 #define max(x, y)			((x) > (y) ? (x) : (y))
diff --git a/sys/dev/drm/include/linux/list.h b/sys/dev/drm/include/linux/list.h
index e4588ba5cf..d1b87268cd 100644
--- a/sys/dev/drm/include/linux/list.h
+++ b/sys/dev/drm/include/linux/list.h
@@ -159,7 +159,10 @@ list_del_init(struct list_head *entry)
 #define list_next_entry(ptr, member)					\
 	list_entry(((ptr)->member.next), typeof(*(ptr)), member)
 
-#define	list_for_each(p, head)						\
+#define list_prev_entry(ptr, member) 					\
+	list_entry(((ptr)->member.prev), typeof(*(ptr)), member)
+
+#define	list_for_each(p, head)					\
 	for (p = (head)->next; p != (head); p = p->next)
 
 #define	list_for_each_safe(p, n, head)					\
@@ -178,6 +181,10 @@ list_del_init(struct list_head *entry)
 	for (p = list_next_entry((p), field); &p->field != (h);		\
 	    p = list_next_entry((p), field))
 
+#define list_for_each_entry_continue_reverse(p, h, field)		\
+	for (p = list_prev_entry((p), field); &p->field != (h);		\
+	    p = list_prev_entry((p), field))
+
 #define list_for_each_entry_safe_from(pos, n, head, member) 			\
 	for (n = list_entry(pos->member.next, typeof(*pos), member);		\
 	     &pos->member != (head);						\
diff --git a/sys/dev/drm/include/linux/lockdep.h b/sys/dev/drm/include/linux/lockdep.h
index 67fda0cda7..3e19ee2bd1 100644
--- a/sys/dev/drm/include/linux/lockdep.h
+++ b/sys/dev/drm/include/linux/lockdep.h
@@ -27,6 +27,8 @@
 #ifndef _LINUX_LOCKDEP_H_
 #define _LINUX_LOCKDEP_H_
 
+struct lock_class_key { };
+
 static inline void
 lockdep_assert_held(struct lock *l)
 {
diff --git a/sys/dev/drm/include/linux/mod_devicetable.h b/sys/dev/drm/include/linux/mod_devicetable.h
index 974658c088..7dd52112f0 100644
--- a/sys/dev/drm/include/linux/mod_devicetable.h
+++ b/sys/dev/drm/include/linux/mod_devicetable.h
@@ -48,4 +48,6 @@ struct dmi_system_id {
 
 int dmi_check_system(const struct dmi_system_id *);
 
+#define I2C_NAME_SIZE	20
+
 #endif	/* _LINUX_MOD_DEVICETABLE_H_ */
diff --git a/sys/dev/drm/include/linux/mutex.h b/sys/dev/drm/include/linux/mutex.h
index 8bbb90d6a6..81c638fe63 100644
--- a/sys/dev/drm/include/linux/mutex.h
+++ b/sys/dev/drm/include/linux/mutex.h
@@ -30,6 +30,9 @@
 #include <sys/lock.h>
 #include <linux/lockdep.h>
 
+#define __mutex_init(lock, name, key)	lockinit((lock), (name), 0, LK_EXCLUSIVE);
+#define mutex_init(lock)		__mutex_init((lock), #lock, NULL)
+
 #define mutex_is_locked(lock)	(lockcount(lock) != 0)
 
 #define mutex_lock(lock)	lockmgr(lock, LK_EXCLUSIVE)
diff --git a/sys/dev/drm/include/linux/page.h b/sys/dev/drm/include/linux/page.h
new file mode 100644
index 0000000000..622b4dec92
--- /dev/null
+++ b/sys/dev/drm/include/linux/page.h
@@ -0,0 +1,53 @@
+/*-
+ * Copyright (c) 2010 Isilon Systems, Inc.
+ * Copyright (c) 2010 iX Systems, Inc.
+ * Copyright (c) 2010 Panasas, Inc.
+ * Copyright (c) 2013, 2014 Mellanox Technologies, Ltd.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice unmodified, this list of conditions, and the following
+ *    disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD: head/sys/ofed/include/linux/page.h 289644 2015-10-20 19:08:26Z hselasky $
+ */
+#ifndef	_LINUX_PAGE_H_
+#define _LINUX_PAGE_H_
+
+#include <linux/types.h>
+
+#include <sys/param.h>
+
+#include <machine/atomic.h>
+#include <vm/vm.h>
+#include <vm/vm_page.h>
+
+#define page	vm_page
+
+#define	virt_to_page(x)	PHYS_TO_VM_PAGE(vtophys((x)))
+
+#define	clear_page(page)		memset((page), 0, PAGE_SIZE)
+#define	pgprot_noncached(prot)		VM_MEMATTR_UNCACHEABLE
+#define	pgprot_writecombine(prot)	VM_MEMATTR_WRITE_COMBINING
+
+#undef	PAGE_MASK
+#define	PAGE_MASK	(~(PAGE_SIZE-1))
+
+#endif	/* _LINUX_PAGE_H_ */
diff --git a/sys/dev/drm/include/linux/platform_device.h b/sys/dev/drm/include/linux/platform_device.h
new file mode 100644
index 0000000000..7a31afdb6a
--- /dev/null
+++ b/sys/dev/drm/include/linux/platform_device.h
@@ -0,0 +1,35 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_PLATFORM_DEVICE_H_
+#define _LINUX_PLATFORM_DEVICE_H_
+
+#endif  /* _LINUX_PLATFORM_DEVICE_H_ */
diff --git a/sys/dev/drm/include/linux/pm_runtime.h b/sys/dev/drm/include/linux/pm_runtime.h
new file mode 100644
index 0000000000..019e5af2bd
--- /dev/null
+++ b/sys/dev/drm/include/linux/pm_runtime.h
@@ -0,0 +1,86 @@
+/*	$NetBSD: pm_runtime.h,v 1.3 2014/08/23 08:03:33 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_PM_RUNTIME_H_
+#define _LINUX_PM_RUNTIME_H_
+
+#include <sys/cdefs.h>
+
+struct device;
+
+static inline void
+pm_runtime_allow(struct device *dev __unused)
+{
+}
+
+static inline void
+pm_runtime_disable(struct device *dev __unused)
+{
+}
+
+static inline int
+pm_runtime_get_sync(struct device *dev __unused)
+{
+	return 0;
+}
+
+static inline void
+pm_runtime_mark_last_busy(struct device *dev __unused)
+{
+}
+
+static inline void
+pm_runtime_put(struct device *dev __unused)
+{
+}
+
+static inline void
+pm_runtime_put_autosuspend(struct device *dev __unused)
+{
+}
+
+static inline void
+pm_runtime_set_active(struct device *dev __unused)
+{
+}
+
+static inline void
+pm_runtime_set_autosuspend_delay(struct device *dev __unused,
+    unsigned ms __unused)
+{
+}
+
+static inline void
+pm_runtime_use_autosuspend(struct device *dev __unused)
+{
+}
+
+#endif  /* _LINUX_PM_RUNTIME_H_ */
diff --git a/sys/dev/drm/include/linux/power_supply.h b/sys/dev/drm/include/linux/power_supply.h
new file mode 100644
index 0000000000..8057d48b29
--- /dev/null
+++ b/sys/dev/drm/include/linux/power_supply.h
@@ -0,0 +1,41 @@
+/*	$NetBSD: power_supply.h,v 1.1 2014/07/16 20:59:58 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_POWER_SUPPLY_H_
+#define _LINUX_POWER_SUPPLY_H_
+
+static inline int
+power_supply_is_system_supplied(void)
+{
+	return 1;
+}
+
+#endif	/* _LINUX_POWER_SUPPLY_H_ */
diff --git a/sys/dev/drm/include/linux/printk.h b/sys/dev/drm/include/linux/printk.h
index 226e8a98c0..796f1a765a 100644
--- a/sys/dev/drm/include/linux/printk.h
+++ b/sys/dev/drm/include/linux/printk.h
@@ -105,6 +105,7 @@ struct va_format {
 	}					\
 } while (0)
 
+#define vprintk	kvprintf
 enum {
 	DUMP_PREFIX_NONE,
 	DUMP_PREFIX_ADDRESS,
diff --git a/sys/dev/drm/include/linux/rbtree.h b/sys/dev/drm/include/linux/rbtree.h
index 864feb3b0b..7cfd9f13c5 100644
--- a/sys/dev/drm/include/linux/rbtree.h
+++ b/sys/dev/drm/include/linux/rbtree.h
@@ -25,10 +25,15 @@
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD: head/sys/ofed/include/linux/rbtree.h 289644 2015-10-20 19:08:26Z hselasky $
  */
 #ifndef	_LINUX_RBTREE_H_
 #define	_LINUX_RBTREE_H_
 
+#ifndef __DragonFly__
+#include <sys/stddef.h>
+#endif
 #include <sys/tree.h>
 
 struct rb_node {
diff --git a/sys/dev/drm/include/linux/rcupdate.h b/sys/dev/drm/include/linux/rcupdate.h
new file mode 100644
index 0000000000..c56845d701
--- /dev/null
+++ b/sys/dev/drm/include/linux/rcupdate.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: rcupdate.h,v 1.2 2014/03/18 18:20:43 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_RCUPDATE_H_
+#define _LINUX_RCUPDATE_H_
+
+#endif  /* _LINUX_RCUPDATE_H_ */
diff --git a/sys/dev/drm/include/linux/reboot.h b/sys/dev/drm/include/linux/reboot.h
new file mode 100644
index 0000000000..ec367ed30c
--- /dev/null
+++ b/sys/dev/drm/include/linux/reboot.h
@@ -0,0 +1,49 @@
+/*	$NetBSD: reboot.h,v 1.2 2015/03/06 01:43:07 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2015 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef	_LINUX_REBOOT_H_
+#define	_LINUX_REBOOT_H_
+
+#include <sys/types.h>
+#include <sys/reboot.h>
+
+/* XXX Implement this by posting a CRITICAL-OVER envsys event?  */
+static inline int
+orderly_poweroff(bool force __unused)
+{
+
+	ksignal(initproc, SIGUSR2);
+
+	return 0;
+}
+
+
+#endif	/* _LINUX_REBOOT_H_ */
diff --git a/sys/dev/drm/include/linux/rwlock.h b/sys/dev/drm/include/linux/rwlock.h
new file mode 100644
index 0000000000..6759b19f65
--- /dev/null
+++ b/sys/dev/drm/include/linux/rwlock.h
@@ -0,0 +1,47 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef	_LINUX_RWLOCK_H_
+#define	_LINUX_RWLOCK_H_
+
+#include <sys/lock.h>
+
+#define	rwlock_init(_l)		lockinit((_l), "DRM rwlock", 0, LK_CANRECURSE)
+#define	read_lock(_l)		lockmgr((_l), LK_EXCLUSIVE)
+#define	write_lock(_l)		read_lock(_l)
+#define	read_unlock(_l)		lockmgr((_l), LK_RELEASE)
+#define	write_unlock(_l)	read_unlock(_l)
+#define	read_lock_irq(_l)	lockmgr((_l), LK_EXCLUSIVE)
+#define	write_lock_irq(_l)	read_lock_irq(_l)
+#define	read_unlock_irq(_l)	lockmgr((_l), LK_RELEASE)
+#define	write_unlock_irq(_l)	read_unlock_irq(_l)
+
+#endif /* _LINUX_RWLOCK_H */
diff --git a/sys/dev/drm/include/linux/screen_info.h b/sys/dev/drm/include/linux/screen_info.h
new file mode 100644
index 0000000000..67cf45a878
--- /dev/null
+++ b/sys/dev/drm/include/linux/screen_info.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: screen_info.h,v 1.1 2014/08/06 13:53:12 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_SCREEN_INFO_H_
+#define _LINUX_SCREEN_INFO_H_
+
+#endif  /* _LINUX_SCREEN_INFO_H_ */
diff --git a/sys/dev/drm/include/linux/slab.h b/sys/dev/drm/include/linux/slab.h
index adcbd7d8ed..3981b83e02 100644
--- a/sys/dev/drm/include/linux/slab.h
+++ b/sys/dev/drm/include/linux/slab.h
@@ -40,5 +40,8 @@ MALLOC_DECLARE(M_DRM);
 } while (0)
 
 #define kcalloc(n, size, flags)	kzalloc((n) * (size), flags)
+#define vmalloc(size)		kmalloc(size, M_DRM, GFP_KERNEL)
+#define vfree(ptr)		kfree(ptr)
+#define vzalloc(size)		kzalloc(size, GFP_KERNEL);
 
 #endif	/* _LINUX_SLAB_H_ */
diff --git a/sys/dev/drm/include/linux/spinlock.h b/sys/dev/drm/include/linux/spinlock.h
index c1a3b32889..9c4768cecb 100644
--- a/sys/dev/drm/include/linux/spinlock.h
+++ b/sys/dev/drm/include/linux/spinlock.h
@@ -31,8 +31,12 @@
 #include <sys/lock.h>
 
 #include <linux/irqflags.h>
+#include <linux/rwlock.h>
 #include <asm/barrier.h>
 
+#define spin_lock_init(x)	spin_init(x, "DRM spinlock")
+#define spin_lock_irqsave(x, f)	{ (void)f; spin_lock(x); }
+#define spin_unlock_irqrestore(x, f) { (void)f; spin_unlock(x); }
 #define spin_is_locked(x)	spin_held(x)
 
 #define assert_spin_locked(x)	KKASSERT(lockcountnb(x))
diff --git a/sys/dev/drm/include/linux/stat.h b/sys/dev/drm/include/linux/stat.h
new file mode 100644
index 0000000000..60de6b9f1b
--- /dev/null
+++ b/sys/dev/drm/include/linux/stat.h
@@ -0,0 +1,37 @@
+/*-
+ * Copyright (c) 2015 The DragonFly Project.  All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ * 3. Neither the name of The DragonFly Project nor the names of its
+ *    contributors may be used to endorse or promote products derived
+ *    from this software without specific, prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
+ * FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
+ * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+ * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_STAT_H
+#define _LINUX_STAT_H
+
+#define S_IRUGO	(S_IRUSR | S_IRGRP | S_IROTH)
+
+#endif /* _LINUX_STAT_H */
diff --git a/sys/dev/drm/include/linux/static_key.h b/sys/dev/drm/include/linux/static_key.h
new file mode 100644
index 0000000000..27bd3f8a08
--- /dev/null
+++ b/sys/dev/drm/include/linux/static_key.h
@@ -0,0 +1 @@
+#include <linux/jump_label.h>
diff --git a/sys/dev/drm/include/linux/string.h b/sys/dev/drm/include/linux/string.h
index 2cdde6e597..d3b02887d9 100644
--- a/sys/dev/drm/include/linux/string.h
+++ b/sys/dev/drm/include/linux/string.h
@@ -64,4 +64,24 @@ kmemdup(const void *src, size_t len, gfp_t gfp)
 	return (dst);
 }
 
+static inline char *
+kstrndup(const char *src, size_t maxlen, gfp_t gfp)
+{
+	char *dst;
+	size_t len;
+
+	if (src == NULL)
+		return NULL;
+
+	len = strnlen(src, maxlen);
+	dst = kmalloc(len + 1, M_DRM, gfp);
+	if (dst == NULL)
+		return NULL;
+
+	memcpy(dst, src, len);
+	dst[len] = '\0';
+
+	return dst;
+}
+
 #endif	/* _LINUX_STRING_H_ */
diff --git a/sys/dev/drm/include/linux/swiotlb.h b/sys/dev/drm/include/linux/swiotlb.h
new file mode 100644
index 0000000000..f3d02945a4
--- /dev/null
+++ b/sys/dev/drm/include/linux/swiotlb.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: swiotlb.h,v 1.1 2014/07/16 20:59:58 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_SWIOTLB_H_
+#define _LINUX_SWIOTLB_H_
+
+#endif  /* _LINUX_SWIOTLB_H_ */
